stages:
  - build
  - verify
  - publish

services:
  - docker:19.03.12-dind
image: omnihr/docker:20210331084634
before_script:
  - apk add --no-cache git make

build:
  stage: build
  cache:
    key: ${CI_JOB_NAME}
    paths:
      - ./images
  artifacts:
    expire_in: 1 week
    paths:
      - ./images
  script:
    - make build
    - make export

lint:
  stage: verify
  script:
    - make lint

test:
  stage: verify
  dependencies: [build]
  script:
    - make import
    - make test

scan:
  stage: verify
  dependencies: [build]
  script:
    - make import
    - make scan

publish:
  stage: publish
  only:
    - master
  dependencies: [build]
  script:
    - make import
    - docker login ${DOCKER_REGISTRY_URI} -u ${DOCKER_REGISTRY_USER} -p ${DOCKER_REGISTRY_PASSWORD}
    - make publish-ci
